<?php
/*
	#############################################################
	# >>> PHP Surveyor  										#
	#############################################################
	# > Author:  Jason Cleeland									#
	# > E-mail:  jason@cleeland.org								#
	# > Mail:    Box 99, Trades Hall, 54 Victoria St,			#
	# >          CARLTON SOUTH 3053, AUSTRALIA
 	# > Date: 	 20 February 2003								#
	#															#
	# This set of scripts allows you to develop, publish and	#
	# perform data-entry on surveys.							#
	#############################################################
	#															#
	#	Copyright (C) 2003  Jason Cleeland						#
	#															#
	# This program is free software; you can redistribute 		#
	# it and/or modify it under the terms of the GNU General 	#
	# Public License as published by the Free Software 			#
	# Foundation; either version 2 of the License, or (at your 	#
	# option) any later version.								#
	#															#
	# This program is distributed in the hope that it will be 	#
	# useful, but WITHOUT ANY WARRANTY; without even the 		#
	# implied warranty of MERCHANTABILITY or FITNESS FOR A 		#
	# PARTICULAR PURPOSE.  See the GNU General Public License 	#
	# for more details.											#
	#															#
	# You should have received a copy of the GNU General 		#
	# Public License along with this program; if not, write to 	#
	# the Free Software Foundation, Inc., 59 Temple Place - 	#
	# Suite 330, Boston, MA  02111-1307, USA.					#
	#############################################################	
*/

$versionnumber = "0.98final";
$dbprefix=strtolower($dbprefix);
define("_PHPVERSION", phpversion());
##################################################################################
## DO NOT EDIT BELOW HERE 
##################################################################################

$realdefaultlang=$defaultlang;

if($_SERVER['SERVER_SOFTWARE'] == "Xitami") //Deal with Xitami Issue
	{
	$_SERVER['PHP_SELF'] = substr($_SERVER['SERVER_URL'], 0, -1) .$_SERVER['SCRIPT_NAME'];
	}

if (!isset($_SERVER["PATH_TRANSLATED"])) {$_SERVER["PATH_TRANSLATED"]=$_SERVER["SCRIPT_FILENAME"];}
if (ereg("WIN", $OS)) {$_SERVER["PATH_TRANSLATED"]=str_replace("\\", "/", $_SERVER["PATH_TRANSLATED"]);}
if (ereg($homedir, $_SERVER["PATH_TRANSLATED"]) && !ereg("dump", $_SERVER['PHP_SELF'])) {
    $sourcefrom="admin";
} else {
	$sourcefrom="public";
}

//IF THIS IS AN ADMIN SCRIPT, RUN THE SESSIONCONTROL SCRIPT
if ($sourcefrom == "admin")
	{
	include("sessioncontrol.php");
	}

//Get rid of the "height" parameter in slstyle for slstyle2 (used for dropdowns)
$slstyle2=eregi_replace("height:...;", "", $slstyle);

//TURN OFF OPTIONS THAT DON'T WORK IN SAFE MODE IF NECESSARY
if (!ini_get('safe_mode'))
	{
	// Only do this if safe_mode is NOT ON
	if (substr($OS, 0, 3) == "WIN") 
		{
		if (isset($mysqldir)) {$mysqlbin=$mysqldir;}
		if (isset($apachedir)) {$htpasswddir=$apachedir;}
		}
	else
		{
		//USING LINUX: Find the location of various files and put that in the appropriate variables!
		if (!isset($mysqlbin) || !$mysqlbin) 
			{
			$temp=`which mysqldump`;
			list($mysqlbin, $discard)=explode(" ", $temp);
			$mysqlbin=substr($mysqlbin, 0, strlen($mysqlbin)-11);
			}
		if (!isset($apachedir) || !$apachedir) 
			{
			$temp=`which htpasswd`;
			list($htpasswddir, $discard)=explode(" ", $temp);
			$htpasswddir=substr($htpasswddir, 0, strlen($htpasswddir)-10);
		    }
		else
			{
			$htpasswddir=$apachedir;
			}
		}
	}
else
	{
	// Safe Mode is ON - turn off security
	$accesscontrol = 0;
	}

//SET LANGUAGE DIRECTORY
if ($sourcefrom == "admin")
	{
	$langdir="$homeurl/lang/$defaultlang";
	$langdir2="$homedir/lang/$defaultlang";
	if (!is_dir($langdir2)) 
		{
		$langdir="$homeurl/lang/english"; //default to english if there is no matching language dir
		$langdir2="$homedir/lang/english";
		}
	require("$langdir2/messages.php");
	}
//SET LOCAL TIME
$localtimedate=(strftime("%Y-%m-%d %H:%M", mktime(date("H")+$timeadjust)));

// SITE STYLES
$setfont = "<font size='2' face='verdana'>";

$singleborderstyle = "style='border: 1px solid #111111'";

//CACHE DATA
$connect=mysql_connect("$databaselocation:$databaseport", "$databaseuser", "$databasepass");
$db=mysql_selectdb($databasename, $connect);

//Admin menus and standards
if ($sourcefrom == "admin") 
	{
	$htmlheader = "<html>\n<head>\n"
				. "<title>$sitename</title>\n"
				. "<meta http-equiv='content-script-type' content='text/javascript' />\n"
				. "<meta http-equiv='Content-Style-Type' content='text/css'>\n"
				. "</head>\n<body topmargin='0' leftmargin='0' marginheight='0' marginwidth='0'>\n"
				. "<table width='100%' align='center' bgcolor='#000000'>\n"
				. "\t<tr>\n"
				. "\t\t<td align='center'>\n"
				. "\t\t\t$setfont<font color='white' size='4'><b>$sitename</b></font></font>\n"
				. "\t\t</td>\n"
				. "\t</tr>\n"
				. "</table>\n";

	function showadminmenu()
		{
		global $accesscontrol, $homedir, $scriptname, $sid, $setfont, $imagefiles;
		$adminmenu  = "<table width='100%' border='0' bgcolor='#DDDDDD'>\n"
					. "\t<tr>\n"
					. "\t\t<td>\n"
					. "\t\t\t<table width='100%' style='border: 1px solid #555555' cellpadding='1' cellspacing='0'>\n"
					. "\t\t\t<tr bgcolor='#555555'>\n"
					. "\t\t\t\t<td colspan='2' height='8'>\n"
					. "\t\t\t\t\t$setfont<font size='1' color='white'><b>"._ADMINISTRATION."</b>\n"
					. "\t\t\t\t</font></font></td>\n"
					. "\t\t\t</tr>\n"
					. "\t\t\t<tr bgcolor='#999999'>\n"
					. "\t\t\t\t<td>\n"
					. "\t\t\t\t\t<input type='image' src='$imagefiles/home.gif' name='HomeButton' alt='"
					. _A_HOME_BT."' title='"
					. _A_HOME_BT."' border='0' align='left' hspace='0' onClick=\"window.open('$scriptname', '_top')\">\n"
					. "\t\t\t\t\t<img src='$imagefiles/blank.gif' alt='-' width='11' border='0' hspace='0' align='left'>\n"
					. "\t\t\t\t\t<img src='$imagefiles/seperator.gif' alt='-' border='0' hspace='0' align='left'>\n";
		if ($accesscontrol == 1)
			{
			$fhtaccess = "$homedir/.htaccess";
			if (!file_exists($fhtaccess))
				{
				$adminmenu .= "\t\t\t\t\t<input type='image' src='$imagefiles/badsecurity.gif' name='AdminSecurity' title='"
							. _A_BADSECURITY_BT."' align='left' border='0' hspace='0' "
							. "onClick=\"window.open('$scriptname?action=editusers', '_top')\">";
				}
			else
				{
				$securityok = checksecurity();
				$adminmenu .= "\t\t\t\t\t<input type='image' src='$imagefiles/security.gif' name='AdminSecurity' title='"
							. _A_SECURITY_BT."' align='left' border='0' hspace='0' "
							. "onClick=\"window.open('$scriptname?action=editusers', '_top')\">";
				}
			}
		else
			{
			$adminmenu .= "\t\t\t\t\t<img src='$imagefiles/blank.gif' alt='-' width='20' border='0' hspace='0' align='left'>\n";
			}
		$adminmenu .= "\t\t\t\t\t<img src='$imagefiles/blank.gif' alt='-' width='20' border='0' hspace='0' align='left'>\n"
					. "\t\t\t\t\t<input type='image' src='$imagefiles/summary.gif' name='CheckSettings' title='"
					. _A_CHECKSETTINGS."' border='0' hspace='0' align='left' "
					. "onClick=\"window.open('$scriptname?action=checksettings', '_top')\">"
					//. "\t\t\t\t\t<img src='$imagefiles/blank.gif' alt='-' width='20' border='0' hspace='0' align='left'>\n"
					. "\t\t\t\t\t<img src='$imagefiles/seperator.gif' alt='|' align='left' hspace='0' border='0'>\n";
	
		$adminmenu .= "\t\t\t\t\t<input type='image' src='$imagefiles/checkdb.gif' name='CheckDatabase' title='"
					. _A_CHECKDB_BT."' border='0' hspace='0' align='left' onClick=\"window.open('checkfields.php', '_top')\">\n";
	
		if ($sid)
			{
			$adminmenu .= "\t\t\t\t\t<input type='image' src='$imagefiles/delete.gif' name='DeleteSurvey' title='"
						. _A_DELETE_BT." ($sid)' border='0' hspace='0' align='left' "
						. "onClick=\"window.open('deletesurvey.php?sid=$sid', '_top')\">";
			}
		else
			{
			$adminmenu .= "\t\t\t\t\t<img src='$imagefiles/blank.gif' alt='-' width='20' border='0' hspace='0' align='left'>\n";
			}
		$adminmenu .= "\t\t\t\t\t<input type='image' src='$imagefiles/export.gif' name='ExportDB' title='"
					. _A_BACKUPDB_BT." ($sid)' border='0' hspace='0' align='left' "
					. "onClick=\"window.open('dumpdb.php', '_top')\">"
					. "\t\t\t\t\t<img src='$imagefiles/seperator.gif' alt='|' align='left' hspace='0' border='0'>\n"
					. "\t\t\t\t\t<input type='image' src='$imagefiles/labels.gif' align='left' name='LabelsEditor' hspace='0' border='0' title='"
					. _Q_LABELS_BT."' onClick=\"window.open('labels.php', '_top')\">\n"
					. "\t\t\t\t\t<img src='$imagefiles/seperator.gif' alt='|' align='left' hspace='0' border='0'>\n"
					. "\t\t\t\t\t<img src='$imagefiles/blank.gif' alt='-' width='20' border='0' hspace='0' align='left'>\n"
					. "\t\t\t\t\t<img src='$imagefiles/seperator.gif' alt='|' align='left' hspace='0' border='0'>\n";
		$adminmenu .= "\t\t\t\t\t<input type='image' src='$imagefiles/templates.gif' name='EditTemplates' title='"
					. _A_TEMPLATES_BT."' border='0' hspace='0' align='left' "
					. "onClick=\"window.open('templates.php', '_top')\">"
					. "\t\t\t\t</td>\n";
		$adminmenu .= "\t\t\t\t<td align='right' width='340'>\n"
					. "\t\t\t\t\t<input type='image' src='$imagefiles/showhelp.gif' name='ShowHelp' title='"
					. _A_HELP_BT."' align='right' hspace='0' border='0' onClick=\"showhelp('show')\">\n"
					. "\t\t\t\t\t<img src='$imagefiles/blank.gif' alt='-' width='42' height='20' align='right' hspace='0' border='0'>\n"
					. "\t\t\t\t\t<img src='$imagefiles/seperator.gif' alt='|' align='right' hspace='0' border='0'>\n"
					. "\t\t\t\t\t<input type='image' src='$imagefiles/add.gif' align='right' hspace='0' border='0' name='AddSurvey' title='"
					. _A_ADDSURVEY_BT."' onClick=\"window.open('$scriptname?action=newsurvey', '_top')\">\n"
					. "\t\t\t\t\t$setfont<font size='1'><b>"._SURVEYS.":</b> "
					. "\t\t\t\t\t<select style='font-size: 9; font-family: verdana; font-color: #333333; background: SILVER; width: 160' "
					. "onChange=\"window.open(this.options[this.selectedIndex].value,'_top')\">\n"
					//. $surveyselect
					. getsurveylist()
					. "\t\t\t\t\t</select>\n"
					. "\t\t\t\t</font></font></td>\n"
					. "\t\t\t</tr>\n"
					. "\t\t</table>\n"
					. "\t</td>\n"
					. "</tr>\n"
					. "</table>\n";
		return $adminmenu;
		}
	}

//DATA TYPES
$qtypeselect = getqtypelist();

//SECURITY SETUP STUFF
$htaccess =<<<EOF
AuthType Basic
AuthName "SURVEYOR: Authorised Users only"
AuthUserFile "$homedir/.htpasswd"
AuthGroupFile /dev/null
Require valid-user
EOF;

function getsurveylist()
	{
	global $sid, $dbprefix, $scriptname;
	$sidquery = "SELECT * FROM {$dbprefix}surveys ORDER BY short_title";
	$sidresult = mysql_query($sidquery);
	if (!$sidresult) {return "Database Error";}
	$surveynames = array();
	$surveyselecter = "";
	while ($sidrow = mysql_fetch_array($sidresult))
		{
		$surveynames[] = array($sidrow['sid'], $sidrow['short_title']);
		}
	if ($surveynames)
		{
		foreach($surveynames as $sv)
			{
			$surveyselecter .= "\t\t\t<option";
			if ($sv[0] == $sid) {$surveyselecter .= " selected"; $svexist = 1;}
			$surveyselecter .=" value='$scriptname?sid=$sv[0]'>$sv[1]</option>\n";
			}
		}
	if (!isset($svexist)) {$surveyselecter = "\t\t\t<option selected>"._AD_CHOOSE."</option>\n".$surveyselecter;}
	else {$surveyselecter = "\t\t\t<option value='$scriptname?sid='>"._NONE."</option>\n".$surveyselecter;}
	return $surveyselecter;
	}

function getquestions()
	{
	global $sid, $gid, $qid, $dbprefix, $scriptname;
	$qquery = "SELECT * FROM {$dbprefix}questions WHERE sid=$sid AND gid=$gid";
	$qresult = mysql_query($qquery);
	$qrows = array(); //Create an empty array in case mysql_fetch_array does not return any rows
	while ($qrow = mysql_fetch_array($qresult)) {$qrows[] = $qrow;} // Get table output into array
	
	// Perform a case insensitive natural sort on group name then question title of a multidimensional array
	usort($qrows, 'CompareGroupThenTitle');
	if (!isset($questionselecter)) {$questionselecter="";}
	foreach ($qrows as $qrow)
		{
		$questionselecter .= "\t\t<option value='$scriptname?sid=$sid&gid=$gid&qid={$qrow['qid']}'";
		if ($qid == $qrow['qid']) {$questionselecter .= " selected"; $qexists="Y";}
		$questionselecter .=">{$qrow['title']}:";
		$questionselecter .= " ";
		$question=strip_tags($qrow['question']);
		if (strlen($question)<35)
			{
			$questionselecter .= $question;
			}
		else
			{
			$questionselecter .= substr($question, 0, 35)."..";
			}
		$questionselecter .= "</option>\n";
		}
	
	if (!isset($qexists))
		{
		$questionselecter = "\t\t<option selected>"._AD_CHOOSE."</option>\n".$questionselecter;
		}
	return $questionselecter;
	}

function getanswers()
	{
	global $sid, $gid, $qid, $code, $dbprefix;
	$aquery = "SELECT * FROM {$dbprefix}answers WHERE qid=$qid ORDER BY sortorder, answer";
	$aresult = mysql_query($aquery);
	$answerselecter = "";
	while ($arow = mysql_fetch_array($aresult))
		{
		$answerselecter .= "\t\t<option value='$scriptname?sid=$sid&gid=$gid&qid=$qid&code={$arow['code']}'";
		if ($code == $arow['code']) {$answerselecter .= " selected"; $aexists="Y";}
		$answerselecter .= ">{$arow['code']}: {$arow['answer']}</option>\n";
		}
	if (!$aexists) {$answerselecter = "\t\t<option selected>"._AD_CHOOSE."</option>\n".$answerselecter;}
	return $answerselecter;
	}

function getqtypelist($SelectedCode = "T", $ReturnType = "selector")
	{
	global $publicurl;
	global $sourcefrom;
	if ($sourcefrom == "admin")
		{
		$qtypes = array(
			"5"=>_5PT,
			"D"=>_DATE,
			//"X"=>_EMAIL,
			"G"=>_GENDER,
			"L"=>_LIST,
			"O"=>_LISTWC,
			"M"=>_MULTO,
			"P"=>_MULTOC,
			"Q"=>_MULTITEXT,
			"N"=>_NUMERICAL,
			"R"=>_RANK,
			"S"=>_STEXT,
			"T"=>_LTEXT,
			"Y"=>_YESNO,
			"A"=>_ARR5,
			"B"=>_ARR10,
			"C"=>_ARRYN,
			"E"=>_ARRMV,
			"F"=>_ARRFL,
			"H"=>_ARRFLC,
			//"V"=>_JSVALIDATEDTEXT,
			"X"=>_BOILERPLATE
			//"Z"=>_SINFL
			);
	
		if ($ReturnType == "array") {return $qtypes;}
		$qtypeselecter = "";
		foreach($qtypes as $TypeCode=>$TypeDescription)
			{
			$qtypeselecter .= "\t\t<option value='$TypeCode'";
			if ($SelectedCode == $TypeCode) {$qtypeselecter .= " selected";}
			$qtypeselecter .= ">$TypeDescription</option>\n";
			}
		return $qtypeselecter;
		}
	}

function getNotificationlist($notificationcode)
	{
	$ntypes = array(
		"0"=>_NT_NONE,
		"1"=>_NT_SINGLE,
		"2"=>_NT_RESULTS
	);
	if (!isset($ntypeselector)) {$ntypeselector="";}
	foreach($ntypes as $ntcode=>$ntdescription)
		{
		$ntypeselector .= "\t\t<option value='$ntcode'";
		if ($notificationcode == $ntcode) {$ntypeselector .= " selected";}
		$ntypeselector .= ">$ntdescription</option>\n";
		}
	return $ntypeselector;
	}

function getgrouplist($gid)
	{
	global $sid, $dbprefix, $scriptname;
	$groupselecter="";
	if (!$sid) {$sid=$_POST['sid'];}
	$gidquery = "SELECT * FROM {$dbprefix}groups WHERE sid=$sid ORDER BY group_name";
	$gidresult = mysql_query($gidquery) or die("Couldn't get group list in common.php<br />$gidquery<br />".mysql_error());
	$gidcount = mysql_num_rows($gidresult);
	if ($gidcount)	
		{
			while ($gidrow = mysql_fetch_array($gidresult))
			{
			$groupnames[] = array($gidrow['gid'], $gidrow['group_name']);
			}
		$groupselecter = "";
		foreach($groupnames as $gv)
			{
			$groupselecter .= "\t\t<option";
			if ($gv[0] == $gid) {$groupselecter .= " selected"; $gvexist = 1;}
			$groupselecter .= " value='$scriptname?sid=$sid&gid=$gv[0]'>$gv[1]</option>\n";
			}
		if (!isset($gvexist)) {$groupselecter = "\t\t<option selected>"._AD_CHOOSE."</option>\n".$groupselecter;}
		else {$groupselecter .= "\t\t<option value='$scriptname?sid=$sid&gid='>"._NONE."</option>\n";}
		}
	return $groupselecter;
	}

function getgrouplist2($gid)
	{
	global $sid, $dbprefix;
	if (!$sid) {$sid=$_POST['sid'];}
	$gidquery = "SELECT * FROM {$dbprefix}groups WHERE sid=$sid ORDER BY group_name";
	$gidresult = mysql_query($gidquery) or die("Plain old did not work!");
	$gidcount = mysql_num_rows($gidresult);
	if ($gidcount)	
		{
			while ($gidrow = mysql_fetch_array($gidresult))
			{
			$groupnames[] = array($gidrow['gid'], $gidrow['group_name']);
			}
		$groupselecter = "";
		foreach($groupnames as $gv)
			{
			$groupselecter .= "\t\t<option";
			if ($gv[0] == $gid) {$groupselecter .= " selected"; $gvexist = 1;}
			$groupselecter .= " value='$gv[0]'>$gv[1]</option>\n";
			}
		if (!$gvexist) {$groupselecter = "\t\t<option selected>"._AD_CHOOSE."</option>\n".$groupselecter;}
		else {$groupselecter .= "\t\t<option value=''>"._NONE."</option>\n";}
		}
	return $groupselecter;
	}

function getgrouplist3($gid)
	{
	global $sid, $dbprefix;
	if (!$sid) {$sid=$_POST['sid'];}
	$gidquery = "SELECT * FROM {$dbprefix}groups WHERE sid=$sid ORDER BY group_name";
	$gidresult = mysql_query($gidquery) or die("Plain old did not work!");
	$gidcount = mysql_num_rows($gidresult);
	if ($gidcount)	
		{
			while ($gidrow = mysql_fetch_array($gidresult))
			{
			$groupnames[] = array($gidrow['gid'], $gidrow['group_name']);
			}
		$groupselecter = "";
		foreach($groupnames as $gv)
			{
			$groupselecter .= "\t\t<option";
			if ($gv[0] == $gid) {$groupselecter .= " selected"; $gvexist = 1;}
			$groupselecter .= " value='$gv[0]'>$gv[1]</option>\n";
			}
		}
	return $groupselecter;
	}

function getuserlist()
	{
	global $dbprefix;
	$uquery = "SELECT * FROM {$dbprefix}users ORDER BY user";
	$uresult = mysql_query($uquery);
	while ($urow = mysql_fetch_array($uresult))
		{
		$userlist[] = array("user"=>$urow['user'], "password"=>$urow['password'], "security"=>$urow['security']);
		}
	return $userlist;
	}

function gettemplatelist()
	{
	global $publicdir;
	if (!$publicdir) {$publicdir=dirname(getcwd());}
	$tloc="$publicdir/templates";
	if ($handle = opendir($tloc))
		{
		while (false !== ($file = readdir($handle))) 
			{		
	   		if (!is_file("$tloc/$file") && $file != "." && $file != "..") 
				{
	       		$list_of_files[] = $file;
	   			}
			}
		closedir($handle);
		}
	return $list_of_files;
	}

function getlanguages()
	{
	global $publicdir;
	if (!$publicdir) {$publicdir = dirname(getcwd());}
	$tloc="$publicdir/lang";
	if ($handle = opendir($tloc))
		{
		while (($file = readdir($handle)) !== false)
			{
			if (!is_dir("$tloc/$file"))
				{
				$langnames[]=substr($file, 0, strpos($file, ".lang.php"));
				}
			}
		}
	return $langnames;
	}

function getadminlanguages()
	{
	global $homedir;
	if (!$homedir) {$homedir = dirname(getcwd());}
	$lloc="$homedir/lang";
	if ($handle = opendir($lloc))
		{
		while (($file = readdir($handle)) !== false)
			{
			if (!is_file("$lloc/$file"))
				{
				if ($file != "." && $file != ".." && $file != "CVS")
					{
					$langnames[]=$file;
					}
				}
			}
		}
	return $langnames;
	}
	
function getlabelsets()
	{
	global $dbprefix;
	$query = "SELECT * FROM {$dbprefix}labelsets ORDER BY label_name";
	$result = mysql_query($query) or die ("Couldn't get list of label sets<br />$query<br />".mysql_error());
	$labelsets=array();
	while ($row=mysql_fetch_array($result))
		{
		$labelsets[] = array($row['lid'], $row['lid'].": ".$row['label_name']);
		}
	return $labelsets;
	}

function checkactivations()
	{
	global $databasename, $dbprefix;
	$tables = mysql_list_tables($databasename);
	$tablenames[] = "ListofTables"; //dummy entry because in_array never finds the first one!
	while ($trow = mysql_fetch_row($tables))
		{
		$tablenames[] = $trow[0];
		}
	$caquery = "SELECT * FROM {$dbprefix}surveys WHERE active='Y'";
	$caresult = mysql_query($caquery);
	if (!$caresult) {return "Database Error";}
	while ($carow = mysql_fetch_array($caresult))
		{
		$surveyname = "{$dbprefix}survey_{$carow['sid']}";
		if (!in_array($surveyname, $tablenames))
			{
			$udquery = "UPDATE {$dbprefix}surveys SET active='N' WHERE sid={$carow['sid']}";
			$udresult = mysql_query($udquery);
			}
		}
	}

function checksecurity()
	{
	// Check that the names in the htpasswd file match up with the names in the database.
	// Any names missing in htpasswd file should be removed from users table
	global $homedir, $dbprefix;
	$fname = "$homedir/.htpasswd";
	$htpasswds = file($fname);
	$realusers[] = "DUMMYRECORD"; //dummy entry because in_array never finds the first one!
	foreach ($htpasswds as $htp)
		{
		list ($fuser, $fpass) = split(":", $htp);
		$realusers[] = $fuser;
		}
	$usquery = "SELECT user FROM {$dbprefix}users";
	$usresult = mysql_query($usquery);
	if (!$usresult) {return "Database Error";}
	while ($usrow = mysql_fetch_array($usresult))
		{
		if (!array_search($usrow['user'], $realusers))
			{
			$dlusquery = "DELETE FROM users WHERE user='{$usrow['user']}'";
			$dlusresult = mysql_query($dlusquery);
			}
		}
	}

function checkfortables()
	{
	global $scriptname, $databasename, $btstyle, $dbprefix, $setfont;
	$alltables=array("{$dbprefix}surveys", 
					 "{$dbprefix}groups", 
					 "{$dbprefix}questions", 
					 "{$dbprefix}answers", 
					 "{$dbprefix}conditions", 
					 "{$dbprefix}users", 
					 "{$dbprefix}labelsets", 
					 "{$dbprefix}labels");
	$tables = array();
	$tablesResult = mysql_list_tables($databasename);
	while ($row = mysql_fetch_row($tablesResult)) $tables[] = $row[0];

	foreach($alltables as $at)
		{
		if (!mysql_table_exists($at, $tables))
			{
			$checkfields="Y";
			}
		}
	if (!isset($checkfields)) {$checkfields="";}
	if ($checkfields=="Y")
		{
		echo "<br />\n"
			."<table width='350' align='center' style='border: 1px solid #555555' cellpadding='1' cellspacing='0'>\n"
			."\t<tr bgcolor='#555555'><td colspan='2' height='4'><font size='1' face='verdana' color='white'><b>"
			._SETUP."</b></td></tr>\n"
			."\t<tr height='22' bgcolor='#CCCCCC'><td align='center'>$setfont\n"
			."\t\t<font color='red'><b>"
			._ERROR."</b></font><br />\n"
			."\t\t"
			._CFT_PROBLEM."<br /><br />\n"
			."\t\t<input $btstyle type='submit' value='"
			._CHECKFIELDS."' onClick=\"window.open('checkfields.php', '_top')\">\n"
			."\t</td></tr>\n"
			."</table>\n"
			."</body></html>\n";
		exit;
		}
	}

function mysql_table_exists($tableName, $tables)
	{
	return(in_array($tableName, $tables));
	}

################################################################################
# Compares two elements from an array (passed by the usort function)
# and returns -1, 0 or 1 depending on the result of the comparison of
# group_name and then title.
function CompareGroupThenTitle($a, $b)
	{
	if (isset($a["group_name"]) && isset($b["group_name"]))
		{
		$GroupResult = strnatcasecmp($a["group_name"], $b["group_name"]);
		}
	else 
		{
		$GroupResult = "";
		}
	if ($GroupResult == 0)
		{
		$TitleResult = strnatcasecmp($a["title"], $b["title"]);
		return $TitleResult;
		}
	return $GroupResult;
	}

function conditionscount($qid)
	{
	global $dbprefix;
	$query="SELECT * FROM {$dbprefix}conditions WHERE qid=$qid";
	$result=mysql_query($query) or die ("Couldn't get conditions<br />$query<br />".mysql_error());
	return mysql_num_rows($result);
	}

function keycontroljs()
	{
	$kcjs=<<<EOF
<SCRIPT TYPE="text/javascript">
<!--

function getkey(e)
	{
	if (window.event) return window.event.keyCode; 
	else if (e) return e.which; else return null;
	} 

function goodchars(e, goods)
	{
	var key, keychar;
	key = getkey(e);
	if (key == null) return true;

	// get character
	keychar = String.fromCharCode(key);
	keychar = keychar.toLowerCase();
	goods = goods.toLowerCase();

	// check goodkeys
	if (goods.indexOf(keychar) != -1)
		return true;

	// control keys
	if ( key==null || key==0 || key==8 || key==9 || key==13 || key==27 )
	   return true;

	// else return false
	return false;
	}
//-->
</SCRIPT>
EOF;
	return $kcjs;
	}

function htmlfooter($url, $explanation)
	{
	global $versionnumber, $setfont, $imagefiles;
	$htmlfooter = "<table width='100%' align='center' bgcolor='#000000'>\n"
				. "\t<tr>\n"
				. "\t\t<td align='center'>\n"
				. "\t\t\t$setfont<font color='white' size='1'>\n"
				. "\t\t\t<img align='right' alt='Help - $explanation' src='$imagefiles/help.gif' "
				. "onClick=\"window.open('$url')\" onMouseOver=\"document.body.style.cursor='pointer'\" "
				. "onMouseOut=\"document.body.style.cursor='auto'\">\n"
				. "\t\t\t<img align='left' alt='Help - $explanation' src='$imagefiles/help.gif' "
				. "onClick=\"window.open('$url')\" onMouseOver=\"document.body.style.cursor='pointer'\" "
				. "onMouseOut=\"document.body.style.cursor='auto'\">\n"
				. "\t\t\t<b><i><a href='http://phpsurveyor.sourceforge.net' target='_blank'>"
				. "<img src='$imagefiles/phpsurveyor_logo.jpg' border='0' alt='PHPSurveyor Logo'></a></i></b>\n"
				. "<br />Ver $versionnumber\n"
				. "\t\t</font></font></td>\n"
				. "\t</tr>\n"
				. "</table>\n"
				. "</body>\n</html>";
	return $htmlfooter;
	}

function fixsortorder($qid) //Function rewrites the sortorder for a group of answers
	{
	global $dbprefix;
	$cdquery = "SELECT * FROM {$dbprefix}answers WHERE qid=$qid ORDER BY sortorder, answer";
	$cdresult = mysql_query($cdquery);
	$position=0;
	while ($cdrow=mysql_fetch_array($cdresult))
		{
		$position=sprintf("%05d", $position);
		if (_PHPVERSION >= "4.3.0")
			{
			$answer = mysql_real_escape_string($cdrow['answer']);
			}
		else
			{
			$answer = mysql_escape_string($cdrow['answer']);
			}
		$cd2query="UPDATE {$dbprefix}answers SET sortorder='$position' WHERE qid={$cdrow['qid']} AND code='{$cdrow['code']}' AND answer='$answer'";
		$cd2result=mysql_query($cd2query) or die ("Couldn't update sortorder<br />$cd2query<br />".mysql_error());
		$position++;
		}
	}

function browsemenubar()
	{
	global $sid, $scriptname, $imagefiles;
	//BROWSE MENU BAR
	if (!isset($surveyoptions)) {$surveyoptions="";}
	$surveyoptions .= "\t<tr bgcolor='#999999'>\n"
					. "\t\t<td>\n"
					. "\t\t\t<input type='image' name='Administration' src='$imagefiles/home.gif' title='"
					. _B_ADMIN_BT."' border='0' align='left' hspace='0' onClick=\"window.open('$scriptname?sid=$sid', '_top')\">\n"
					. "\t\t\t<img src='$imagefiles/blank.gif' alt='-' width='11' border='0' hspace='0' align='left'>\n"
					. "\t\t\t<img src='$imagefiles/seperator.gif' alt='|' border='0' hspace='0' align='left'>\n"
					. "\t\t\t<input type='image' name='SurveySummary' src='$imagefiles/summary.gif' title='"
					. _B_SUMMARY_BT."' border='0' align='left' hspace='0' onClick=\"window.open('browse.php?sid=$sid', '_top')\">\n"
					. "\t\t\t<input type='image' name='ViewAll' src='$imagefiles/document.gif' title='"
					. _B_ALL_BT."' border='0' align='left' hspace='0' onClick=\"window.open('browse.php?sid=$sid&action=all', '_top')\">\n"
					. "\t\t\t<input type='image' name='ViewLast' src='$imagefiles/viewlast.gif' title='"
					. _B_LAST_BT."' border='0' align='left' hspace='0' onClick=\"window.open('browse.php?sid=$sid&action=all&limit=50&order=desc', '_top')\">\n"
					. "\t\t\t<img src='$imagefiles/seperator.gif' border='0' hspace='0' align='left'>\n"
					. "\t\t\t<input type='image' name='DataEntry' src='$imagefiles/dataentry.gif' title='"
					. _S_DATAENTRY_BT."' align='left' border='0' hspace='0' onclick=\"window.open('dataentry.php?sid=$sid', '_top')\">\n"
					. "\t\t\t<input type='image' name='Printable' src='$imagefiles/print.gif' title='"
					. _S_PRINTABLE_BT."' align='left' border='0' hspace='0' onclick=\"window.open('printablesurvey.php?sid=$sid', '_blank')\">\n"
					. "\t\t\t<input type='image' name='Statistics' src='$imagefiles/statistics.gif' title='"
					. _B_STATISTICS_BT."' align='left' border='0' hspace='0' onclick=\"window.open('statistics.php?sid=$sid', '_top')\">\n"
					. "\t\t\t<img src='$imagefiles/seperator.gif' border='0' hspace='0' align='left'>\n"
					. "\t\t\t<input type='image' name='Export' src='$imagefiles/export.gif' title='"
					. _B_EXPORT_BT."' align='left' border='0' hspace='0' onclick=\"window.open('export.php?sid=$sid', '_blank')\">\n"
					. "\t\t\t<input type='image' name='SaveDump' src='$imagefiles/save.gif' title='"
					. _B_BACKUP_BT."' align='left' border='0' hspace='0' onclick=\"window.open('resultsdump.php?sid=$sid', '_top')\">\n"
					. "\t\t</td>\n"
					. "\t</tr>\n";
	return $surveyoptions;
	}

function returnglobal($stringname)
	{
	if (_PHPVERSION < "4.1.0") 
		{
		if (isset($HTTP_GET_VARS[$stringname])) {return $HTTP_GET_VARS[$stringname];}
		elseif (isset($HTTP_POST_VARS[$stringname])) {return $HTTP_POST_VARS[$stringname];}
		}
	else 
		{
		if (isset($_GET[$stringname])) {return $_GET[$stringname];}
		elseif (isset($_POST[$stringname])) {return $_POST[$stringname];}
		}
	}

function sendcacheheaders()
	{
	global $defaultlang, $thissurvey;
	if (isset($thissurvey['language'])) {$language=$thissurvey['language'];} 
	else {$language=$defaultlang;} //$thissurvey['language'] will exist if this is a public survey
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");  // always modified
	header("Cache-Control: no-store, no-cache, must-revalidate");  // HTTP/1.1
	header("Cache-Control: post-check=0, pre-check=0", false);
	header("Pragma: no-cache");
	switch($language) 
		{
 		case "simplified-chinese":
 			header ('Content-Type: text/html; charset=gb2312');
 			break;
		case "chinese":
			header ('Content-Type: text/html; charset=Big5'); 
			break;
		case "arabic":
			header ('Content-Type: text/html; charset=iso-8859-6');
			break;
		case "japanese":
			header ('Content-Type: text/html; charset=iso-2022-jp');
			break;
		case "greek":
			header ('Content-Type: text/html; charset=iso-8859-7');
			break;
		case "korean":
			header ('Content-Type: text/html; charset=iso-2022-kr');
			break;
		case "thai":
			header ('Content-Type: text/html; charset=windows-874');
			break;
		case "english":
		case "italian":
		case "spanish":
		case "deutsch":
			header ('Content-Type: text/html; charset=ISO-8859-1');
			break;
		default:
			header ('Content-Type: text/html; charset=ISO-8859-1');
			break;
		}
	}

function getLegitQids($sid)
	{
	global $dbprefix;
	$lq = "SELECT DISTINCT qid FROM {$dbprefix}questions WHERE sid=$sid"; //GET LIST OF LEGIT QIDs FOR TESTING LATER
	$lr = mysql_query($lq);
	$legitqs[] = "DUMMY ENTRY";
	while ($lw = mysql_fetch_array($lr))
		{
		$legitqs[] = $lw['qid']; //this creates an array of question id's'
		}
	return $legitqs;
	}

function returnquestiontitlefromfieldcode($fieldcode)
	{
	if (!isset($fieldcode)) {return "Preset";}
	if ($fieldcode == "token") {return "Token";}
	if ($fieldcode == "datestamp") {return "Date Stamp";}
	global $dbprefix, $sid;
	
	//Find matching information;
	$detailsarray=arraySearchByKey($fieldcode, createFieldMap($sid), "fieldname");
	foreach ($detailsarray as $dt) {
		$details=$dt;
	}
	
	$fqid=$details['qid'];
	$qq = "SELECT question, other FROM {$dbprefix}questions WHERE qid=$fqid";
	
	$qr = mysql_query($qq);
	if (!$qr)
		{
		echo "<!-- ERROR Finding Question Name for qid $fqid - $qq - ".mysql_error()."! -->";
		$qname="[QID: $fqid]";
		}
	else 
		{
		while($qrow=mysql_fetch_array($qr, MYSQL_ASSOC))
			{
			$qname=strip_tags($qrow['question']);
			}
		}
	if (isset($details['aid']) && $details['aid']) //Add answer if necessary (array type questions)
		{
		$qq = "SELECT answer FROM {$dbprefix}answers WHERE qid=$fqid AND code='{$details['aid']}'";
		$qr = mysql_query($qq) or die ("ERROR: ".mysql_error()."<br />$qq");
		while($qrow=mysql_fetch_array($qr, MYSQL_ASSOC))
			{
			$qname.=" [".$qrow['answer']."]";
			}
		}
	if (substr($fieldcode, -5) == "other") 
		{
		$qname .= " [Other]";
		}
	return $qname;
	}

function getsidgidqid($fieldcode)
	{
	list($fsid, $fgid, $fqid) = split("X", $fieldcode);
	$legitqs=getLegitQids($fsid);
	if (!$fqid) {$fqid=0;}
	$oldfqid=$fqid;
	while(!in_array($fqid, $legitqs))
		{
		$fqid=substr($fqid, 0, strlen($fqid)-1);
		}
	if (strlen($fqid) < strlen($oldfqid)) 
		{
	    $faid=substr($oldfqid, strlen($fqid), strlen($oldfqid)-strlen($fqid));
		$oldfqid="";
		}
	else
		{
		$faid="";
		}
	return array("sid"=>$fsid, "gid"=>$fgid, "qid"=>$fqid, "aid"=>$faid);
	}

function getextendedanswer($fieldcode, $value)
	{
	global $dbprefix, $sid;
	//Fieldcode used to determine question, $value used to match against answer code
	//Returns NULL if question type does not suit
	if (substr_count($fieldcode, "X") > 1) //Only check if it looks like a real fieldcode
		{
		$detailsarray=arraySearchByKey($fieldcode, createFieldMap($sid), "fieldname");
		foreach ($detailsarray as $dt) {
			$fields=$dt;
		}
		//Find out the question type
		$query = "SELECT type, lid FROM {$dbprefix}questions WHERE qid={$fields['qid']}";
		$result = mysql_query($query) or die ("Couldn't get question type - getextendedanswer() in common.php<br />".mysql_error());
		while($row=mysql_fetch_array($result))
			{
			$this_type=$row['type'];
			$this_lid=$row['lid'];
			} // while
		switch($this_type)
			{
			case "L":
			case "O":
			case "R":
				$query = "SELECT code, answer FROM {$dbprefix}answers WHERE qid={$fields['qid']} AND code='".mysql_escape_string($value)."'";
				$result = mysql_query($query) or die ("Couldn't get answer type L - getextendedanswer() in common.php<br />$query<br />".mysql_error());
				while($row=mysql_fetch_array($result))
					{
					$this_answer=$row['answer'];
					} // while
				if ($value == "-oth-") 
					{
				    $this_answer=_OTHER;
					}
				break;
			case "M":
			case "P":
				switch($value)
					{
					case "Y": $this_answer=_YES; break;
					}
				break;
			case "Y":
				switch($value)
					{
					case "Y": $this_answer=_YES; break;
					case "N": $this_answer=_NO; break;
					default: $this_answer=_NOANSWER;
					}
				break;
			case "G":
				switch($value)
					{
					case "M": $this_answer=_MALE; break;
					case "F": $this_answer=_FEMALE; break;
					default: $this_answer=_NOANSWER;
					}
				break;
			case "C":
				switch($value)
					{
					case "Y": $this_answer=_YES; break;
					case "N": $this_answer=_NO; break;
					case "U": $this_answer=_UNCERTAIN; break;
					}
				break;
			case "E":
				switch($value)
					{
					case "I": $this_answer=_INCREASE; break;
					case "D": $this_answer=_DECREASE; break;
					case "S": $this_answer=_SAME; break;
					}
				break;
			case "F":
			case "H":
				$query = "SELECT title FROM {$dbprefix}labels WHERE lid=$this_lid AND code='$value'";
				$result = mysql_query($query) or die ("Couldn't get answer type F/H - getextendedanswer() in common.php");
				while($row=mysql_fetch_array($result))
					{
					$this_answer=$row['title'];
					} // while
				break;
			default:
				;
			} // switch
		}
	if (isset($this_answer))
		{
	    return $this_answer." [$value]";
		}
	else
		{
		return $value;
		}
	}

function validate_email($email)
	{
	global $OS;
	// Create the syntactical validation regular expression
	$regexp = "^([_a-z0-9-]+)(\.[_a-z0-9-]+)*@([a-z0-9-]+)(\.[a-z0-9-]+)*(\.[a-z]{2,4})$";
	// Presume that the email is invalid
	$valid = 0;
	// Validate the syntax
	if (eregi($regexp, $email))
		{
		$valid=1;
//The following also checks that there is a valid MX DNS record for the domain,
//however this is probably unnecessary - some emails work fine without one so
//it is removed.
//		list($username,$domaintld) = split("@",$email);
//		if (ereg("WIN", $OS))
//			{
//			$valid = 1;
//			}
//		else
//			{
//			// Validate the domain
//			if (getmxrr($domaintld,$mxrecords))
//	         $valid = 1;
//			}
		}
	else
		{
		$valid = 0;
		}
	return $valid;
	}
function crlf_lineendings($text)
	{
	$text=str_replace("\r\n", "~~~~", $text); //First replace any good line endings with ~~~~
	$text=str_replace("\n", "~~~~", $text); //Then replace any solitary \n's with ~~~~
	$text=str_replace("\r", "~~~~", $text); //Then replace any solitary \r's with ~~~~
	$text=str_replace("~~~~", "\r\n", $text); //Finally replace all ~~~~'s with \r\n
	return $text;
	}

function createFieldMap($sid) {
	//This function generates an array containing the fieldcode, and matching data in the same
	//order as the activate script
	global $dbprefix;
	//Check for any additional fields for this survey and create necessary fields (token and datestamp)
	$pquery = "SELECT private, datestamp FROM {$dbprefix}surveys WHERE sid=$sid";
	$presult=mysql_query($pquery);
	while($prow=mysql_fetch_array($presult))
		{
		if ($prow['private'] == "N") 
			{
			$fieldmap[]=array("fieldname"=>"token", "type"=>"", "sid"=>$sid, "gid"=>"", "qid"=>"", "aid"=>"");
			}
		if ($prow['datestamp'] == "Y")
			{
			$fieldmap[]=array("fieldname"=>"datestamp", "type"=>"", "sid"=>$sid, "gid"=>"", "qid"=>"", "aid"=>"");
			}
		}
	//Get list of questions
	$aquery = "SELECT * FROM {$dbprefix}questions, {$dbprefix}groups WHERE {$dbprefix}questions.gid={$dbprefix}groups.gid AND {$dbprefix}questions.sid=$sid ORDER BY group_name, title";
	$aresult = mysql_query($aquery) or die ("Couldn't get list of questions in createFieldMap function.<br />$query<br />".mysql_error());
	while ($arow=mysql_fetch_array($aresult)) //With each question, create the appropriate field(s)
		{
		if ($arow['type'] != "M" && $arow['type'] != "A" && $arow['type'] != "B" && $arow['type'] !="C" && $arow['type'] != "E" && $arow['type'] != "F" && $arow['type'] != "H" && $arow['type'] !="P" && $arow['type'] != "R" && $arow['type'] != "Q")
			{
			$fieldmap[]=array("fieldname"=>"{$arow['sid']}X{$arow['gid']}X{$arow['qid']}", "type"=>"{$arow['type']}", "sid"=>$sid, "gid"=>$arow['gid'], "qid"=>$arow['qid'], "aid"=>"");
			switch($arow['type'])
				{
				case "L":  //DROPDOWN LIST
					if ($arow['other'] == "Y") 
						{
						$fieldmap[]=array("fieldname"=>"{$arow['sid']}X{$arow['gid']}X{$arow['qid']}other", 
										  "type"=>$arow['type'], 
										  "sid"=>$sid, 
										  "gid"=>$arow['gid'], 
										  "qid"=>$arow['qid'], 
										  "aid"=>"other");
						// dgk bug fix line above. aid should be set to "other" for export to append to the field name in the header line.
						}
					break;
				case "O": //DROPDOWN LIST WITH COMMENT
					$fieldmap[]=array("fieldname"=>"{$arow['sid']}X{$arow['gid']}X{$arow['qid']}comment", 
									  "type="=>$arow['type'], 
									  "sid"=>$sid, 
									  "gid"=>$arow['gid'], 
									  "qid"=>$arow['qid'], 
									  "aid"=>"comment");
					// dgk bug fix line below. aid should be set to "comment" for export to append to the field name in the header line. Also needed set the type element correctly.
					break;
				}
			}
		elseif ($arow['type'] == "M" || $arow['type'] == "A" || $arow['type'] == "B" || $arow['type'] == "C" || $arow['type'] == "E" || $arow['type'] == "F" || $arow['type'] == "H" || $arow['type'] == "P")
			{
			//MULTI ENTRY
			$abquery = "SELECT {$dbprefix}answers.*, {$dbprefix}questions.other FROM {$dbprefix}answers, {$dbprefix}questions WHERE {$dbprefix}answers.qid={$dbprefix}questions.qid AND sid=$sid AND {$dbprefix}questions.qid={$arow['qid']} ORDER BY {$dbprefix}answers.sortorder, {$dbprefix}answers.answer";
			$abresult=mysql_query($abquery) or die ("Couldn't get list of answers in createFieldMap function (case M/A/B/C/E/F/H/P)<br />$abquery<br />".mysql_error());
			while ($abrow=mysql_fetch_array($abresult))
				{
				$fieldmap[]=array("fieldname"=>"{$arow['sid']}X{$arow['gid']}X{$arow['qid']}{$abrow['code']}", "type"=>$arow['type'], "sid"=>$sid, "gid"=>$arow['gid'], "qid"=>$arow['qid'], "aid"=>$abrow['code']);
				if ($abrow['other']=="Y") {$alsoother="Y";}
				if ($arow['type'] == "P")
					{
					$fieldmap[]=array("fieldname"=>"{$arow['sid']}X{$arow['gid']}X{$arow['qid']}{$abrow['code']}comment", "type"=>$arow['type'], "sid"=>$sid, "gid"=>$arow['gid'], "qid"=>$arow['qid'], "aid"=>"comment");
					}
				}
			if ((isset($alsoother) && $alsoother=="Y") && ($arow['type']=="M" || $arow['type']=="P"))
				{
				$fieldmap[]=array("fieldname"=>"{$arow['sid']}X{$arow['gid']}X{$arow['qid']}other", "type"=>$arow['type'], "sid"=>$sid, "gid"=>$arow['gid'], "qid"=>$arow['qid'], "aid"=>"other");
				if ($arow['type']=="P")
					{
					$fieldmap[]=array("fieldname"=>"{$arow['sid']}X{$arow['gid']}X{$arow['qid']}othercomment", "type"=>$arow['type'], "sid"=>$sid, "gid"=>$arow['gid'], "qid"=>$arow['qid'], "aid"=>"othercomment");
					}
				}
			}
		elseif ($arow['type'] == "Q")
			{
			$abquery = "SELECT {$dbprefix}answers.*, {$dbprefix}questions.other FROM {$dbprefix}answers, {$dbprefix}questions WHERE {$dbprefix}answers.qid={$dbprefix}questions.qid AND sid=$sid AND {$dbprefix}questions.qid={$arow['qid']} ORDER BY {$dbprefix}answers.sortorder, {$dbprefix}answers.answer";
			$abresult=mysql_query($abquery) or die ("Couldn't get list of answers in createFieldMap function (type Q)<br />$abquery<br />".mysql_error());
			while ($abrow=mysql_fetch_array($abresult))
				{
				$fieldmap[]=array("fieldname"=>"{$arow['sid']}X{$arow['gid']}X{$arow['qid']}{$abrow['code']}", "type"=>$arow['type'], "sid"=>$sid, "gid"=>$arow['gid'], "qid"=>$arow['qid'], "aid"=>$abrow['code']);
				}
			}
		elseif ($arow['type'] == "R")
			{
			//MULTI ENTRY
			$abquery = "SELECT {$dbprefix}answers.*, {$dbprefix}questions.other FROM {$dbprefix}answers, {$dbprefix}questions WHERE {$dbprefix}answers.qid={$dbprefix}questions.qid AND sid=$sid AND {$dbprefix}questions.qid={$arow['qid']} ORDER BY {$dbprefix}answers.sortorder, {$dbprefix}answers.answer";
			$abresult=mysql_query($abquery) or die ("Couldn't get list of answers in createFieldMap function (type R)<br />$abquery<br />".mysql_error());
			$abcount=mysql_num_rows($abresult);
			for ($i=1; $i<=$abcount; $i++)
				{
				$fieldmap[]=array("fieldname"=>"{$arow['sid']}X{$arow['gid']}X{$arow['qid']}$i", "type"=>$arow['type'], "sid"=>$sid, "gid"=>$arow['gid'], "qid"=>$arow['qid'], "aid"=>$i);
				}			
			}
		}
	return $fieldmap;
}

function arraySearchByKey($needle, $haystack, $keyname, $maxanswers="") {
	$output=array();
	foreach($haystack as $hay) {
		if (array_key_exists($keyname, $hay)) {
		    if ($hay[$keyname] == $needle) {
				if ($maxanswers == 1) {
				    return $hay;
				} else {
			        $output[]=$hay;
				}
		    }
		}
	}
	return $output;
}
?>