# Database : `phpsurveyor`
# 
# --------------------------------------------------------
#
# Table structure for table `answers`
#

CREATE TABLE `answers` (
  `qid` int(11) NOT NULL default '0',
  `code` varchar(5) NOT NULL default '',
  `answer` text NOT NULL,
  `default_value` char(1) NOT NULL default 'N',
  `sortorder` varchar(5) default NULL
) TYPE=MyISAM;

# --------------------------------------------------------
#
# Table structure for table `conditions`
#

CREATE TABLE `conditions` (
  `cid` int(11) NOT NULL auto_increment,
  `qid` int(11) NOT NULL default '0',
  `cqid` int(11) NOT NULL default '0',
  `cfieldname` varchar(50) NOT NULL default '',
  `method` char(2) NOT NULL default '',
  `value` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`cid`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

# --------------------------------------------------------
#
# Table structure for table `groups`
#

CREATE TABLE `groups` (
  `gid` int(11) NOT NULL auto_increment,
  `sid` int(11) NOT NULL default '0',
  `group_name` varchar(100) NOT NULL default '',
  `description` text,
  PRIMARY KEY  (`gid`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

# --------------------------------------------------------
#
# Table structure for table `labels`
#

CREATE TABLE `labels` (
  `lid` int(11) NOT NULL default '0',
  `code` varchar(5) NOT NULL default '',
  `title` varchar(50) NOT NULL default '',
  `sortorder` varchar(5) default NULL
) TYPE=MyISAM;

# --------------------------------------------------------
#
# Table structure for table `labelsets`
#

CREATE TABLE `labelsets` (
  `lid` int(11) NOT NULL auto_increment,
  `label_name` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`lid`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

# --------------------------------------------------------
#
# Table structure for table `questions`
#

CREATE TABLE `questions` (
  `qid` int(11) NOT NULL auto_increment,
  `sid` int(11) NOT NULL default '0',
  `gid` int(11) NOT NULL default '0',
  `type` char(1) NOT NULL default 'T',
  `title` varchar(20) NOT NULL default '',
  `question` text NOT NULL,
  `help` text,
  `other` char(1) NOT NULL default 'N',
  `mandatory` char(1) default NULL,
  `lid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`qid`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

# --------------------------------------------------------
#
# Table structure for table `surveys`
#

CREATE TABLE `surveys` (
  `sid` int(11) NOT NULL auto_increment,
  `short_title` varchar(50) NOT NULL default '',
  `description` text,
  `admin` varchar(50) default NULL,
  `active` char(1) NOT NULL default 'N',
  `welcome` text,
  `expires` date default NULL,
  `adminemail` varchar(100) default NULL,
  `private` char(1) default NULL,
  `faxto` varchar(20) default NULL,
  `format` char(1) default NULL,
  `template` varchar(100) default 'default',
  `url` varchar(255) default NULL,
  `urldescrip` varchar(255) default NULL,
  `language` varchar(50) default '',
  `datestamp` char(1) default 'N',
  `usecookie` char(1) default 'N',
  `notification` char(1) default '0',
  `allowregister` char(1) default 'N',
  `attribute1` varchar(255) default NULL,
  `attribute2` varchar(255) default NULL,
  `email_invite` text,
  `email_remind` text,
  `email_register` text,
  `email_confirm` text,
  PRIMARY KEY  (`sid`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

# --------------------------------------------------------
#
# Table structure for table `users`
#

CREATE TABLE `users` (
  `user` varchar(20) NOT NULL default '',
  `password` varchar(20) NOT NULL default '',
  `security` varchar(10) NOT NULL default ''
) TYPE=MyISAM;
